/* stampa_numeri.c */

/* Direttive */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "tabint.h"

#define ROW_LENGTH 256


/* Prototipi delle procedure secondarie e definizione di tipi */

void InterpretaLineaComando (int argc, char *argv[], char *filemosse);

/* Carica dal file filedati nella tabella T i numeri da stampare */
void CaricaVettoreInteri (char *filedati, tabint *pT);


/* Programma principale */
int main (int argc, char *argv[])
{
  char filedati[ROW_LENGTH];
  tabint T;


  /* Legge da linea di comando il file che contiene i dati */
  InterpretaLineaComando(argc,argv,filedati);

  /* Carica i numeri da filedati in una tabella */
  CaricaVettoreInteri(filedati,&T);

  /* Stampa i numeri */
  stampatabint(&T);

  /* Cancella il primo elemento */
  canctabint(&T,1);
  printf("card = %d\n",cardtabint(&T));

  /* Stampa i numeri */
  stampatabint(&T);

  /* Aggiunge il numero 47 */
  instabint(&T,47);
  printf("card = %d\n",cardtabint(&T));

  /* Stampa i numeri */
  stampatabint(&T);

  distruggetabint(&T);

  return EXIT_SUCCESS;
}


/* Definizione delle procedure secondarie */

/* Legge dalla linea di comando il file che contiene i dati */
void InterpretaLineaComando (int argc, char *argv[], char *filedati)
{
  if (argc != 2)
  {
    fprintf(stderr,"Errore nella linea di comando!\n");
    exit(EXIT_FAILURE);
  }

  strcpy(filedati,argv[1]);
}


/* Carica dal file filedati nella tabella T i numeri da stampare */
void CaricaVettoreInteri (char *filedati, tabint *pT)
{
  FILE *fp;
  int n, i;
  int u;


  fp = fopen(filedati,"r");
  if (fp == NULL)
  {
    fprintf(stderr,"File %s non apribile!\n",filedati);
    exit(EXIT_FAILURE);
  }

  n = 0;
  while (fscanf(fp,"%d",&u) == 1)
    n++;

  /* Crea la tabella T di dimensione n */
  creatabint(pT,n);

  rewind(fp);

  /* Scorrere il file inserendo gli elementi letti nella tabella T */
  for (i = 1; i <= n; i++)
  {
    fscanf(fp,"%d",&u);
    instabint(pT,u);
  }

  fclose(fp);
}
